<?php

// This is old code, dinosaurs were around when it was first written...

// uploadget - get name of uploaded image file
//
//      $index          name of FORM input (type="file" name="$index")
//      $dir            directory to copy uploaded file to
//      $prefix         code to rename image file with (for unique file names)
//      $overwrite      boolean to overwrite
//      $ren            name to rename file to (ignores $prefix)

function uploadget($index, $dir = ".", $prefix = "", $overwrite = 0, $ren = "") {

	if (!isset($_FILES) || !isset($_FILES[$index]))
		return NULL;

	if (substr($dir,-1) != "/") $dir .= "/";

	$file = $_FILES[$index];

	debug("'$file'");

	$file_uploaded = ($ren != "") ? $ren : $prefix.$file['name'];

	$file_uploaded = strtolower($file_uploaded);
	$file_uploaded = str_replace('.jpeg','.jpg',$file_uploaded);

	if (file_exists($dir.$file_uploaded) && !$overwrite) {
		debug("file already exists [overwrite=0]:($dir$file_uploaded)");
		unlink($file['tmp_name']);
		return "$file_uploaded already exists!";
	}

	if (isset($file['error']) && $file['error']) {
		debug("upload error: '{$file['error']}'");
		return "upload error ({$file['error']})!";
	}
	if (!$file['size']) {
		debug("no size (or oversize)");
		return "no content!";
	}
	if (!is_uploaded_file($file['tmp_name'])) {
		debug("no file '{$file['tmp_name']}'");
		return "no file!";
	}

	define('WIDTH',0);
	define('HEIGHT',1);
	define('TYPE',2);

	$types = array(IMAGETYPE_GIF,IMAGETYPE_JPEG,IMAGETYPE_PNG);
	$size = getimagesize($file['tmp_name']);
	if (array_search($size[TYPE],$types) === FALSE) {
		debug("file is wrong type ({$size[TYPE]} / {$size['mime']})");
		unlink($file['tmp_name']);
		return "file is wrong type!";
	}

	if ($ren != "") {
		$types = array(IMAGETYPE_GIF => ".gif",IMAGETYPE_JPEG => ".jpg",IMAGETYPE_PNG => ".png");
		$file_uploaded .= $types[$size[TYPE]];
	}

	if (!move_uploaded_file($file['tmp_name'],$dir.$file_uploaded)) {
		debug("failed to save file '$dir$file_uploaded'");
		return "failed to save file!";
	}

	debug("moved ({$file['tmp_name']},$dir$file_uploaded)");

	return $file;
}


/* uploadfile - get a file upload based on type (extenstion) */

// can't just strstr mime types because .ini does not have one

function uploadfile(&$status, &$filename, $types = array('.txt')) {

	$data = '';
	$status = '';	
	$file = $_FILES['file'];

	$filename = $file['name'];		// set the reference

	if (!$file['name'])
		$status = "please select a file";
	else
	if ($file['error'])
		$status = "PHP indicated error: {$file['error']}";
	else
	if ($file['size'] == 0)
		$status = "file submitted had no data!";

	if ($status == '') {
		$i = 0;
		foreach ($types as $typ)
			$i += strrpos($file['name'],$typ);
		if ($i == 0)
			$status = "invalid file type";
	}

	if ($status == '') {
		$data = file_get_contents($file['tmp_name']);
		if ($data == FALSE)
			$status = "unable to read file";
	}

	if ($file['tmp_name'])
		unlink($file['tmp_name']);

	debug($status);

	return $data;
}


/* downloadfile - download posts, pages, data files */

function downloadfile($data, $file) {

	if (debug()) debuglog(0);
	header('Content-Type: text/plain');
	header('Content-Length: '.strlen($data));
	header('Content-Disposition: attachment; filename="'.$file.'"');
	echo($data);
	exit;
}

?>
