<?php

/* TESTING.PHP - temporary file for testing the code

Once the site has been setup, this file can be deleted and then either 
FILEMODE.PHP or MYSQL.PHP should be moved into the MOD/ directory 
depending on whether the site is to be configured for file mode or for 
MySQL mode.
*/

if (version_compare(PHP_VERSION, '5.3.0') == -1)
	exit('Sorry. PHP must be greater than 5.3.0. (We use goto.)');

if (defined('DB_NAME')) {
	include 'mysql.php';
	_config_mysql();
}
else
if (defined('FILEMODE')) {
	include 'filemode.php';
}
else {
	// if in setup may need this
	$button = postvar('button');
	if (config('admin') && in_array($button,array("setup","write","test"))
				&& !isset($_POST['filemode'])) {
		include 'mysql.php';
		_config_mysql();
	}
	else {
		include 'filemode.php';
	}
}
