<?php

/* DAT/DATA.PHP - display site data */

function data() {

	if (!isset($_POST['f']))
		$_POST['c'] = $_POST['h'] = $_POST['e'] = $_POST['r'] = 'on';

	include 'rules.php';			// only to show $rules array

	$arg = getvar('arg');
	$url = "?arg=$arg&amp;op=data";
	$section = config('arg');

	$f = (postvar('f')) ? postvar('f') : 'var_export';
	$c = (postvar('c')) ? 'checked' : '';
	$h = (postvar('h')) ? 'checked' : '';
	$e = (postvar('e')) ? 'checked' : '';
	$r = (postvar('r')) ? 'checked' : '';
	$s = (postvar('s')) ? 'checked' : '';

echo <<<HTML
<div class='menu'>
<span>
<span class='help' style='cursor:default;'></span>
<p>The <b>data</b> command displays <u>all</u> internal data created and used 
by the core code.<br><br>
The core data arrays are:<br><br>
<tt>\$config</tt> configuration data<br>
<tt>\$html</tt> HTML and templates<br>
<tt>\$error</tt> error handling array<br>
<tt>\$rules</tt> the "rules" array<br>
<tt>\$_SERVER</tt> the PHP array<br><br>
The data is output by the <u>selected</u> PHP function.<br><br>
The <tt>\$config</tt> and <tt>\$html</tt> data displayed here will have section 
<b>$section</b> specific data.
</p>
</span>
</div>
HTML;

echo <<<HTML
<form method="post" action="$url">
<tt>\$config</tt>&ensp;<input type="checkbox" name="c" $c>&ensp;
<tt>\$html</tt>&ensp;<input type="checkbox" name="h" $h>&ensp;
<tt>\$error</tt>&ensp;<input type="checkbox" name="e" $e>&ensp;
<tt>\$rules</tt>&ensp;<input type="checkbox" name="r" $r>&ensp;
<tt>\$_SERVER</tt>&ensp;<input type="checkbox" name="s" $s>&ensp;
<select name="f">
<option>var_export</option>
<option>var_dump</option>
<option>print_r</option>
</select>&ensp;
<button>view</button>
<button name="button" value="done" formaction="?arg=$arg">done</button>
</form>
HTML;

	echo "<pre>";
	ob_start('obentities');
	if ($c) {
		echo "\n\n\$config = ";
		$f(config());
	}
	if ($h) {
		if ($f == "var_export") echo "\n";
		echo "\n\$html = ";
		$f(html());
	}
	if ($e) {
		if ($f == "var_export") echo "\n";
		echo "\n\$error = ";
		$f(_error());
	}
	if ($r) {
		if ($f == "var_export") echo "\n";
		echo "\n\$rules = ";
		$f(_rules());
	}
	if ($s) {
		if ($f == "var_export") echo "\n";
		echo "\n\$_SERVER = ";
		$f($_SERVER);
	}
	ob_end_flush();
	echo "</pre>";
}
