<?php

/* DAT/MESSAGES.PHP - Admin code for Admin supplementary "templates"

This file, although not readily editable by an HTML editor, has several
"templates" for Admin to display messages and stuff.
*/

function messages($msg) {		// for use by an Admin function
global $messages;

	return $messages[$msg];
// can also just use: $GLOBALS['messages'][$msg]
}

$messages['post'] = <<<'HTML'
<a class="e" href="$url$id" title="edit record $id">$id</a>
<a class="p" href="$url$id&amp;preview=1" title="preview record $id"></a>
<a class="x" href="$urldel$id" title="delete record $id{$html['confirmdelete']}"></a>
<a class="c" href="$urlcmt$id" title="$comments"></a>
&ensp;<a class="d" href="$url$id&amp;get">{$record['title']}</a>
<br>

HTML;

$messages['page'] = <<<'HTML'
<a class="e" href="$url$page" title="edit page $page">$page</a>
<a class="p" href="$url$page&amp;preview=1" title="preview page $page"></a>
<a class="x" href="$urldel$page" title="delete page $page{$html['confirmdelete']}"></a>
&ensp;<a class="d" href="$url$page&amp;get">{$record['title']}</a>
<br>

HTML;

$messages['makepagedir'] = <<<'HTML'
<span style="float:left;">page directory does not exist&nbsp;</span>
<form>
<input type="hidden" name="arg" value="$arg">
<input type="hidden" name="type" value="page">
<input type="hidden" name="make" value="pages">
<button title="make $arg page directory">make</button>
</form>

HTML;

// some of these should be in files and *not* in here as they are rarely used

$messages['passwordsaved'] = <<<HTML
<!--messages.php-->
<div id="password">
<p>Password has been updated. You will have log back in.</p>
<form title="\$formtitle" method="get" action="{\$_SERVER['PHP_SELF']}">
<p><input type="submit" value="done">
<input type="hidden" name="arg" value="\$arg"></p>
</form>
</div>
<p>\$status</p>

HTML;

$messages['password'] = <<<HTML
<!--messages.php-->
<div id="password">
Please carefully enter the 'admin' password twice and click <b>update password</b> to use a new password.
<form title="\$formtitle" method="post" name="password" action="{\$html['host']}">
<p>Password:
<input style="margin-top:-5px;" type="text" name="password" value="\$password" size=30><br>
Password:
<input type="text" name="password2" value="\$password2" size=30></p>
<p><input type="submit" name="button" value="update password">
<input type="submit" name="button" value="cancel">
<span style="color:red;"><b>\$status</b></span>
</p>
</form>
</div>

HTML;

$messages['okayfine'] = <<<HTML
<!--messages.php-->
<div>
You will next be redirected back to the Admin page and you will have to login with the created <tt>name</tt> and <tt>password</tt> (cookies will need to be enabled).<br>
<form title="\$formtitle" method="get" action="{\$_SERVER['PHP_SELF']}">
<p><input type="submit" value="done">
</form>
</div>
<p>\$status</p>
HTML;

// confirmation dialogs

// NOTE these use the following ($_url)
$_url = '?'.htmlspecialchars($_SERVER['QUERY_STRING']);

$messages['confirm'] = <<<HTML
\$preamble
<div id="confirm">
<p>Really Do This?</p>
<p>\$action</p>
<form title="$formtitle" method="post" action="$_url">
<input type="submit" name="yes" value="yes">
<input type="submit" name="button" value="cancel">
</form>
</div>

HTML;

// optionally create one for each delete action like this:

$messages['confirm_comment'] = <<<HTML
Preparing to delete comment \$id (post \$id)...
<div id="confirm">
<p>Really Do This?</p>
<p>delete comment \$id</p>
<form title="$formtitle" method="post" action="$_url">
<input type="submit" name="yes" value="yes">
<input type="submit" name="button" value="cancel">
</form>
</div>

HTML;

// preview gets inserted into the HTML for previewing a post in Admin 
// (finally realized how to center it--sheesh!)

$messages['preview'] = <<<HTML

<div style='position:fixed;bottom:10px;left:0;width:100%;text-align:center;'><span style='padding:3px 5px;border:1px solid orange;background-color:yellow;font:13px courier;opacity:0.6;'>This is the preview. Relative links will not work correctly.</span></div>

HTML;


// the setup button

$messages['setup'] = <<<HTML
<span><input id="setup" type="submit" name="button" value="setup">
<span>setup admin account &amp; MySQL parameters exit <tt>file mode</tt></span></span>
HTML;
