<?php

$html['menu'] = '<div id="menu"><a href="{$html[\'argurl\']}">Home</a></div>';

$html['open'] = <<<HTML
<!DOCTYPE html>
<!-- open.html (wp) -->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>{\$html['title']}</title>
<link href="{\$html['themedir']}default.css" rel="stylesheet" type="text/css">
</head>
<body>
<div id="main">
<header>
<hgroup>
<h1><a href="{\$config['siteurl']}" title="{\$config['sitename']}">{\$config['sitename']}</a></h1>
</hgroup>
</header>
<img style="width:100%;" src="{\$config['siteurl']}{\$html['themedir']}header.jpg">
{\$html['menu']}
<div id="content">
{\$html['navmenu']}

HTML;

$html['close'] = <<<HTML

<!-- close.html (wp) -->
</div> <!-- content -->
</div>
<div id="footer">
<a href="{\$config['siteurl']}">Not powered by WordPress</a>
</div>
</body>
</html>
HTML;

$html['entries'] = <<<HTML
<!-- entries.html (wp) -->
<div class="entry" id="{\$record['id']}" style="width: 80%;">
<span class="title"><a href="{\$record['post']}#content">{\$record['title']}</a></span>
<span class="date">Posted on <a href="{\$record['post']}#content"><b>{\$record['date']}</b></a></span>
<div class="body">
{\$record['body']}
<div class="more">{\$record['murl']}</div>
<span class="url">{\$record['curl']}</span>
</div>
</div>

HTML;

$html['entry'] = <<<HTML
<!-- entry.html (wp) -->
<div class="entry">
<span class="date">Posted on <a href="{\$record['post']}"><b>{\$record['date']}</b></a></span>
<div class="body">
<span class="title">{\$record['title']}</span>
{\$record['body']}
<div style="color:#666;font-size:80%;margin-top:15px;">Bookmark the <a href="{\$record['post']}"><b>permalink</b></a>.</div>
</div>
</div>

HTML;

$html['comment'] = <<<HTML
<!-- comment.html (wp) -->
<div class="comment" id="{\$record['id']}">
{\$record['from']} on <a href="#{\$record['id']}"><b>{\$record['date']}</b></a> said: <br>
{\$record['body']}
</div>

HTML;

$html['commentsintro'] = <<<HTML
<a id="comments"></a>
<div class="commentintro">
{\$html['feedbacklink']}
</div>

HTML;

$html['commentsmax'] = <<<HTML
<div class="commentmax">
Maximum number of comments reached.
</div>

HTML;

$html['commentpreview'] = <<<'HTML'
<!-- commentpreview (default) -->
<div class="commentform" id="comments">
Comment Preview:
</div>

HTML;
$html['commentform'] = <<<HTML
<!-- commentform (wp) -->
<div class="commentform">
<form name="commentadd" method="post" action="{\$html['formurl']}#comments">
<div class="commentadd">
Leave a Reply
</div>
<label for="from">{\$html['fromlink']}</label><input type="text" name="from" value="{\$_POST['from']}" size=30 maxlength=32>
<label for="title">Website</label><input type="text" name="title" value="{\$_POST['title']}" size=30 maxlength=64>
<label for="comment">Comment</label><textarea name="comment" rows=6>{\$_POST['comment']}</textarea>
<div class="note" style="margin-bottom: 10px;">
No Cookies, Javascript, or "Registering" required.<br>
Formatting: *<b>bold</b>* ^<i>italic</i>^ _<u>underline</u>_ '<code>code</code>'.
<br>All HTML will be stripped and there is a {\$config['postlimit']} byte limit.
</div>
<input class="{\$html['formsubmit']}" {\$html['formsubmit']} type="submit" name="button" value="submit">
<span style="color:red;">{\$html['comment_message']}</span>
</form>
</div>

HTML;

$html['moreprev'] = '
<div style="text-align:center;height:4px;">
<span class="right" style="visibility:{$html[\'more_vis\']};"><a href="{$html[\'argurl\']}&amp;start={\$html[\'count\']}" title="view more posts">Next&rarr;</a></span>
{\$html[\'gototop\']}
<span class="left" style="visibility:{\$html[\'prev_vis\']};"><a href="{$html[\'argurl\']}&amp;start={\$html[\'start\']}" title="view previous posts">&larr;Previous</a></span>
</div>
';
