<?php
/*
	"I wake up in the morning with ideas that please me, and some of
	those ideas actually please me also later in the day when I've
	entered them into my computer."
	  -- Donald Knuth
*/

// All include files are here; there are no classes, no global objects,
// and no nested includes.

// This is the "maintenance mode" message; uncomment when upgrading. If theme 
// has changed the path to the file should be updated.
//readfile('htm/message.html');
//exit;

$GLOBALS['VERSION'] = '1.4.1';			// gets put into config data

include 'error.php';
include 'rules.php';
include 'dat/defines.php';			// MySQL and Admin passwords

foreach (glob('inc/*.php') as $inc)		// include all libraries
	include($inc);

foreach (glob('mod/*.php') as $inc) {		// include all modules
	include($inc);
	modules_set($inc);
}

modules_init();					// initialize all data

if (is_file('testing.php'))
	include 'testing.php';			// see file TESTING

$file = html('themedir')."functions.php";	// theme code (optional)
if (is_file($file)) {
	debug("'$file'");
	include $file;
}

$op = getvar('op');				// $_GET alias
rules_run($op);					// see RULES.PHP

// Do not change anything below this line!
